/*********************************************ͷļ******************************************/
#include <hal_led.h>
#include <hal_assert.h>
#include <hal_board.h>
#include <hal_int.h>
#include "hal_mcu.h"
#include "hal_button.h"
#include "hal_rf.h"
#include "basic_rf.h"
#include "c51_gpio.h"
#include "c51_rtc.h"

/****************************************************************************************/
#define TX                  1       // ģʽ
#define RX                  0       // ģʽ

#define TX_ADDR             0x2520  // ͵ַ 
//#define TX_ADDR             0x2543  // ͵ַ
#define RX_ADDR             0xBEEF  // յַ
//#define RX_ADDR             0x2520  // յַ
//#define RX_ADDR             0x2543  // յַ

#define RF_CHANNEL          11      // 2.4 GHz RF channel 11 - 26  Ϊ5MHZ
#define PAN_ID              0x2007  // PAN ID

#define SEND_LENGTH         5       // ÿĳ
#define RF_PKT_MAX_SIZE     30      // ݰֵ

/************************************************ȫֱ****************************************/
static basicRfCfg_t basicRfConfig;
static uint8    pRxData[RF_PKT_MAX_SIZE];               // ջ
static uint8    pTxData[SEND_LENGTH] = { "123\r\n" };   // Ҫ͵
static uint16   SendCnt = 0;                            // ͵ݰ
static uint16   RecvCnt = 0;                            // յݰ

/****************************************************************************************/
static void RF_SendPacket(void);        // ͺ
static void RF_RecvPacket(void);        // պ
static void RF_Initial(uint8 mode);     // RFʼ
static void RST_System(void);           // ϵͳ

/*************************************************************************************************
*     RF_Initial() => ʼRFоƬ
*     mode, =0,ģʽ else,ģʽ
*************************************************************************************************/
static void RF_Initial(uint8 mode)
{
    // õַ
	if (RX == mode)     { basicRfConfig.myAddr = RX_ADDR; } 
	else                { basicRfConfig.myAddr = TX_ADDR; }    

    basicRfConfig.panId = PAN_ID;           // ýڵPAN ID
    basicRfConfig.channel = RF_CHANNEL;     // ýڵŵ
    basicRfConfig.ackRequest = TRUE;        // Ӧ  
    
    if (basicRfInit(&basicRfConfig) == FAILED)      { HAL_ASSERT(FALSE); }
          
    halRfSetTxPower(4);                     // Ϊ20dbm

    if (RX == mode)     { basicRfReceiveOn();  } 
    else                { basicRfReceiveOff(); }                 
}

/*************************************************************************************************
*  RST_System() => ϵͳϵͳѺ
*************************************************************************************************/
static void RST_System(void)
{
    halMcuInit();       // ³ʼMCU
    halMcuWaitMs(5);    // ȴ5msϵͳȶ
    RF_Initial(TX);     // ³ʼRF
}

/*************************************************************************************************
*  : BSP_RF_SendPacket() => ߷ݺ                            *
* ˵ Sendbufferָ͵ݣlengthݳ                     *
*************************************************************************************************/
static void RF_SendPacket(void)
{ 
    // һݣжǷͳɹյӦ
    if (!basicRfSendPacket(RX_ADDR, pTxData, SEND_LENGTH))
//    basicRfSendPacket(RX_ADDR, pTxData, SEND_LENGTH);
    {
        SendCnt++;
        halLedClear(1);         // LED˸ָʾͳɹյӦ
    }
    halMcuWaitMs(500);
    halLedSet(1);
    HAL_PAEN_OFF();
    HAL_LNAEN_OFF();
    HAL_HGM_OFF();
    C51_RTC_EnterSleep();       // ϵͳģʽPM2͹ģ2sRTC
    RST_System();               // ³ʼϵͳ 
    HAL_PAEN_ON();
    HAL_LNAEN_ON();
    HAL_HGM_ON();
}

/*************************************************************************************************
*  RF_RecvPacket() => ݽմ
*************************************************************************************************/
static void RF_RecvPacket(void)
{
    uint8 length = 0;
    
    while (!basicRfPacketIsReady());    // ģǷѾԽһ

    // յݸƵpRxData
    if ((length=basicRfReceive(pRxData, RF_PKT_MAX_SIZE, NULL)) > 0) 
    {
        // жϽǷȷ
        if ((SEND_LENGTH==length) && (pRxData[0]=='1')\
        && (pRxData[1]=='2') && (pRxData[2]=='3'))
        {
            RecvCnt++;
            
            // ˸LEDָʾյȷ
            halLedClear(1);
            halMcuWaitMs(500);
            halLedSet(1);
        }                                  
    }
}

/*************************************************************************************************
*  : main() => 
* ˵ ͷÿ2sRTCһΣһݣÿݳΪ5ֽڣ"123/r/n",ɫLED
         ˸ͳɹյȷӦݡ
         շ: յݳΪ5ֽڣǰΪ123ݽȷͬʱɫLED˸һ
         ָʾյȷݡ
         ע⣺appMode = TXͳ򣩣 =RXճ
*************************************************************************************************/
void main(void)
{
    uint8 appMode = RX;
    
    halBoardInit();                                         // ʼΧ豸

    if (appMode == TX)              { C51_RTC_Initial(); }  // ʼRTC
    
    if (halRfInit() == FAILED)      { HAL_ASSERT(FALSE); }  // Ӳrfгʼ
         
//    MDMTEST1 |= 0X12; 
    
    RF_Initial(appMode);                                    // ʼRF
    
    if (!C51_GPIO_ioDetective())    { halLedClear(2); }     // IO⣬жIOǷж̽ӣ·
    C51_GPIO_OffDetective();                                // ޹IOΪ룬͹
    
//    Sleep   
//    halLedSet(1);
//    HAL_PAEN_OFF();
//    HAL_LNAEN_OFF();
//    HAL_HGM_OFF();
//    C51_RTC_EnterSleep();       // ϵͳģʽPM2͹ģ2sRTC
       
    while (1)
    {
        if      (appMode == RX)     { RF_RecvPacket(); }    // ģ
        else if (appMode == TX)     { RF_SendPacket(); }    // ģ
        // Role is undefined. This code should not be reached
        //HAL_ASSERT(FALSE);   
    }
}












